import { DialogSOP } from '../../libappsop/dialogsop';
import { EditFieldSOP } from '../../libappsop/editfieldsop';

export interface DialogScenarioFields {
  Name?: string;
  Assumption?: string;
  Comment?: string;
}

export class DialogScenario extends DialogSOP<DialogScenarioFields> {
  public static readonly title = 'Scenario';

  public efName = new EditFieldSOP('edtName');
  public efAssumption = new EditFieldSOP('edtAssumption');
  public efComment = new EditFieldSOP('edtComment');

  public constructor() {
    super('DialogCreateEditScenario', 'btnOK'); // TODO: standardize OK button to have small "k"

    // Set UI element mapping to pair the UI name to the UI element for use in DialogSOP to find the UI object to set value or verify value
    // This prevents each new Dialog to duplicate code just to set/verify UI element value
    this._uiMap.set('Name', this.efName);
    this._uiMap.set('Assumption', this.efAssumption);
    this._uiMap.set('Comment', this.efComment);
  }
}
